<div align="center"><img src="./docs/assets/nautil-logo.png" width="200" height="200"></div>

<div align="center">Enterprise Level Business System Frontend Framework</div>
<div align="center">企业级业务系统前端框架</div>

## Introduction

Nautil (nautil.js) is a javascript frontend framework which helps you to build enterprise level cross-platform business system by using familiar React syntax.<br>
Nautil (nautil.js) 是一个基于 React 语法快速构建企业级的跨平台业务系统的前端框架。

The purpose of Nautil is to make complex business system development more systematic, easy and efficient.<br>
她的目标是使复杂业务系统的开发结构更清晰，效率更高。

Nautil (nautil.js) is built on React and is a framework, not a UI library. Developers can use React components in Nautil applications directly as possible. *Nautil is absolutely React, however, Nautil is more than React.* As a framework, it provides MVC architecture, router/navigation, state management, model management, event stream management, internationalization and ability of cross-platform.<br>
她是基于 React 的框架（而非 UI 库）。开发者可以无缝地直接在 Nautil 中使用 React 的组件。*Nautil 就是 React，但 Nautil 不止于 React。* 作为框架，她还提供了 MVC 架构、路由、状态管理、模型管理、事件流管理、国际化以及跨平台等一系列框架应该具备的套件。

Without importing all the ecosystem of React, without complex redux, without any more choice of third part libraries, you will begin and build your application quickly with Nautil. Feel happy and relaxing when you writing with Nautil. It will work as what you think. You do not need to learn more than react. The only thing you need to know is some feature level api. There is no syntax level or higher knowledge to learn. Try it, I belive, you will fall in love with Nautil in 5 minutes.<br>
不需要把整个 React 生态里面的东西都引入进来了，不需要复杂的 redux，不需要一大堆第三方库，你现在只需要使用到 Nautil 就可以开始快速构建你的应用。轻松上阵吧！它会按照你所想的那样工作，除了 React 本身，你不需要学更多复杂的内容了，你要了解的全都是 API 层面的东西，不会再有新语法让你去学了。现在开始吧，我相信你会在 5 分钟内爱上她！

## Install

```
npm i nautil
```

## Documention

- [Documents](https://nautil.js.org)
- [中文文档](https://www.tangshuang.net/7273.html)

## Related Efforts

- [nautil-cli](https://github.com/tangshuang/nautil-cli) - The CLI tool for Nautil to make your development more easy.
- [tyshemo](https://github.com/tangshuang/tyshemo) - A data type checker, Model generator library which is used in Nautil to help developers to crete models.

## Maintainers

[@tangshuang](https://github.com/tangshuang).

## Contributing

Feel free to dive in! [Open an issue](https://github.com/tangshuang/nautil/issues/new) or submit PRs.

## Road Map

- [x] TypeScript declare file supports (highest priority)
- [ ] Unit test
- [ ] Eslint rules in nautil-cli
- [ ] testing tasks in nautil-cli
- [x] React Native in nautil-cli
- [x] Wechat miniprogram

## MIT License

Copyright 2019 tangshuang

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
